
// Copyright (c) 2015, Lawrence Livermore National Security, LLC.
// Produced at the Lawrence Livermore National Laboratory.
//
// This file is part of Caliper.
// Written by David Boehme, boehme3@llnl.gov.
// LLNL-CODE-678900
// All rights reserved.
//
// For details, see https://github.com/scalability-llnl/Caliper.
// Please also see the LICENSE file for our additional BSD notice.
//
// Redistribution and use in source and binary forms, with or without modification, are
// permitted provided that the following conditions are met:
//
//  * Redistributions of source code must retain the above copyright notice, this list of
//    conditions and the disclaimer below.
//  * Redistributions in binary form must reproduce the above copyright notice, this list of
//    conditions and the disclaimer (as noted below) in the documentation and/or other materials
//    provided with the distribution.
//  * Neither the name of the LLNS/LLNL nor the names of its contributors may be used to endorse
//    or promote products derived from this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS
// OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
// LAWRENCE LIVERMORE NATIONAL SECURITY, LLC, THE U.S. DEPARTMENT OF ENERGY OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
// WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
// ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

/// @file services.inc.cpp
/// Static list of all available Caliper service modules.

namespace cali
{
extern CaliperService alloc_service;
extern CaliperService aggregate_service;
#ifdef CALIPER_HAVE_LIBUNWIND
extern CaliperService callpath_service;
#endif
#ifdef CALIPER_HAVE_PAPI
extern CaliperService papi_service;
#endif
#ifdef CALIPER_HAVE_LIBPFM
extern CaliperService libpfm_service;
#endif
extern CaliperService debug_service;
extern CaliperService env_service;
extern CaliperService git_service;
extern CaliperService cmake_service;
extern CaliperService event_service;
extern CaliperService textlog_service;
extern CaliperService recorder_service;
extern CaliperService report_service;
#ifdef CALIPER_HAVE_SAMPLER
extern CaliperService sampler_service;
#endif
extern CaliperService timestamp_service;
extern CaliperService statistics_service;
#ifdef CALIPER_HAVE_DYNINST
extern CaliperService symbollookup_service;
#endif
#ifdef CALIPER_HAVE_DYNINST
extern CaliperService instlookup_service;
#endif
extern CaliperService trace_service;
extern CaliperService validator_service;
const CaliperService caliper_services[] = {
    alloc_service,
    aggregate_service,
#ifdef CALIPER_HAVE_LIBUNWIND
    callpath_service,
#endif
#ifdef CALIPER_HAVE_PAPI
    papi_service,
#endif
#ifdef CALIPER_HAVE_LIBPFM
    libpfm_service,
#endif
    debug_service,
    env_service,
    git_service,
    cmake_service,
    event_service,
    textlog_service,
    recorder_service,
    report_service,
#ifdef CALIPER_HAVE_SAMPLER
    sampler_service,
#endif
    timestamp_service,
    statistics_service,
#ifdef CALIPER_HAVE_DYNINST
    symbollookup_service,
#endif
#ifdef CALIPER_HAVE_DYNINST
    instlookup_service,
#endif
    trace_service,
    validator_service,
    { nullptr, nullptr }
};

}